//************************
//csvMode=0;//日報
//csvMode=1;//月報
//csvMode=2;//年報
//csvMode=3;//年度報
//csvMode=4;//1分間報
//************************


//************************
//*OnLoad
//************************
$(function()
{
  //画面タイトル設定
  $("#title").text(title);
	
  //今日の日付データを変数todayに格納
  var optionLoop, this_day, this_month, this_year, today;
  today      = new Date();
  this_year  = today.getFullYear();
  this_month = today.getMonth() + 1;
  this_day   = today.getDate();
  
	//各htmlへのリンク
	switch (csvMode)
	{
		case 0:
			$("#monitor").html("<a href='../monitor.html'>発電電力</a>");
			$("#minute").html("<a href='./minute.html'>1分間報</a>");
			$("#day").html("<a href='#'>日報</a>");			
			$("#month").html("<a href='./month.html'>月報</a>");
			$("#year").html("<a href='./year.html'>年報</a>");
			$("#term").html("<a href='./term.html'>年度報</a>");

			break;
		case 1:
			$("#monitor").html("<a href='../monitor.html'>発電電力</a>");
			$("#minute").html("<a href='./minute.html'>1分間報</a>");
			$("#day").html("<a href='./day.html'>日報</a>");
			$("#month").html("<a href='#'>月報</a>");			
			$("#year").html("<a href='./year.html'>年報</a>");
			$("#term").html("<a href='./term.html'>年度報</a>");

			break;
		case 2:
			$("#monitor").html("<a href='../monitor.html'>発電電力</a>");
			$("#minute").html("<a href='./minute.html'>1分間報</a>");
			$("#day").html("<a href='./day.html'>日報</a>");
			$("#month").html("<a href='./month.html'>月報</a>");
			$("#year").html("<a href='#'>年報</a>");			
			$("#term").html("<a href='./term.html'>年度報</a>");

			break;
		case 3:
			$("#monitor").html("<a href='../monitor.html'>発電電力</a>");
			$("#minute").html("<a href='./minute.html'>1分間報</a>");
			$("#day").html("<a href='./day.html'>日報</a>");
			$("#month").html("<a href='./month.html'>月報</a>");
			$("#year").html("<a href='./year.html'>年報</a>");
			$("#term").html("<a href='#'>年度報</a>");			

			break;
		case 4:
			$("#monitor").html("<a href='../monitor.html'>発電電力</a>");
			$("#minute").html("<a href='#'>1分間報</a>");			
			$("#day").html("<a href='./day.html'>日報</a>");
			$("#month").html("<a href='./month.html'>月報</a>");
			$("#year").html("<a href='./year.html'>年報</a>");
			$("#term").html("<a href='./term.html'>年度報</a>");

			break;
	  default:
	    	console.log('csvModeがhtmlで設定されていない');	
			
	}
	
  //年月日のドロップダウンリストに項目を追加。現在の年月日を選択状態にする。
  setOption(this_year, this_month, this_day);


});

//************************************************
//* 年月日のドロップダウンリストに項目を追加。
//* 年月日を選択状態にする。
//************************************************
function setOption(this_year, this_month, this_day) 
{
	
	switch (csvMode)
	{
		case 0:
		case 4:
			//年
		  for (var i = common.year.first; i <= common.year.end ; i++)
		  {
					$('#selectYear').append($('<option>').html(i).val(i));
					
					if(i == this_year)
					{
						//現在の年を選択状態にする
						$('#selectYear').val(i);
					}
		  }

			//月
		  for (var i = common.month.first; i <= common.month.end ; i++)
		  {
					$('#selectMonth').append($('<option>').html(i).val(i));
					
					if(i == this_month)
					{
						//現在の月を選択状態にする
						$('#selectMonth').val(i);
					}
		  }
		  
		  //日
		  for (var i = common.day.first; i <= common.day.end ; i++)
		  {
					$('#selectDay').append($('<option>').html(i).val(i));

					if(i == this_day)
					{
						//1日前を選択状態にする
						$('#selectDay').val(i - 1);
					}
		  }		
			
			break;
			
		case 1:
		
			//年
		  for (var i = common.year.first; i <= common.year.end ; i++)
		  {
					$('#selectYear').append($('<option>').html(i).val(i));
					
					if(i == this_year)
					{
						//現在の年を選択状態にする
						$('#selectYear').val(i);
					}
		  }

			//月
		  for (var i = common.month.first; i <= common.month.end ; i++)
		  {
					$('#selectMonth').append($('<option>').html(i).val(i));
					
					if(i == this_month)
					{
						//先月を選択状態にする
						$('#selectMonth').val(i - 1);
					}
		  }		
			
			break;
			
		case 2:
			//年報
		  for (var i = common.year.first; i <= common.year.end ; i++)
		  {
					$('#selectYear').append($('<option>').html(i).val(i));
					
					if(i == this_year)
					{
						//1年前を選択状態にする
						$('#selectYear').val(i - 1);
					}
		  }
			
			break;
		
		case 3:
			//年度報
		  for (var i = common.year.first; i <= common.year.end ; i++)
		  {
					$('#selectYear').append($('<option>').html(i).val(i));
					
					if(i == this_year)
					{
						if(this_month < 4)
						{
							//1～3月の場合、2年前を選択状態にする
							$('#selectYear').val(i - 2);
							
						}
						else
						{
							//4月以降の場合、1年前を選択状態にする
							$('#selectYear').val(i - 1);
						}
					}
		  }
			
			break;
			
		default:
	}
};
  

//************************
//*ファイル名生成
//************************
function CreateCsvFile()
{
	var Url = "http://" + csvUrl + "/report/csv/";
	var csvFile;
	
	switch (csvMode)
	{
		case 0:
		 	var year  = $("#selectYear").val();
			var month = $("#selectMonth").val();
			var day   = $("#selectDay").val();

			//TEST
			//year  = 2017;
			//month = 6;
			//day   = 21;

			//月と日の有効桁数は2。ゼロパディングする。
			month = ('00' + month).slice(-2);
			day   = ('00' + day).slice(-2);

			csvFile = Url + year + month + day + ".csv";
			
			break;
		
		case 1:
		 	var year  = $("#selectYear").val();
			var month = $("#selectMonth").val();

			//TEST
			//year  = 2017;
			//month = 6;

			//月の有効桁数は2。ゼロパディングする。
			month = ('00' + month).slice(-2);

			csvFile = Url + year + month + ".csv";
			
			break;

		case 2:
		 	var year  = $("#selectYear").val();

			//TEST
			//year  = 2017;

			csvFile = Url + year + ".csv";
					
			break;
					
		case 3:
		 	var year  = $("#selectYear").val();

			//TEST
			//year  = 2017;

			csvFile = Url + year + "n.csv";
					
			break;

		case 4:
		 	var year  = $("#selectYear").val();
			var month = $("#selectMonth").val();
			var day   = $("#selectDay").val();

			//TEST
			//year  = 2017;
			//month = 6;
			//day   = 21;

			//月と日の有効桁数は2。ゼロパディングする。
			month = ('00' + month).slice(-2);
			day   = ('00' + day).slice(-2);

			csvFile = Url + year + month + day + "min.csv";
			
			break;
		
		default:
	}

	return csvFile;
}


// パスからファイル名を取得
function getFileName(path) 
{
    var result = '';
    if (path) 
    {
        var paths = path.split('/');
        result = paths.pop();
    }
    
    return result;
}
    
//************************
//*ダウンロード
//************************
function DownloadDayCsv()
{
	
	//ダウンロードパス
	var csvFile = CreateCsvFile();
		
	$.ajax({
			url: csvFile,
			type: 'GET',
			dataType: 'text',
			cache: false,
			async: false,
			timeout: 30000,
			beforeSend: function(xhr){
				xhr.overrideMimeType("text/html;charset=Shift_JIS");
		  },
			
	})
	.done(function(data) {

		//パスからファイル名を取得
		var savefileName = getFileName(csvFile);
		
		if(savefileName.length < 13)
		{		
			//保存するファイル名を13文字にする
			var point = savefileName.indexOf(".");
			var front = savefileName.substr(0, point);
			var rear = savefileName.substr(point);
			
			front = (front + '_________').slice(0, 9);
			
			savefileName = front + rear;
		}

	  //bom付にする(csvがエクセルで開けるようになる)
	  var bom = new Uint8Array([0xEF, 0xBB, 0xBF]);
	  
	  var blob = new Blob([ bom, data ], { "type" : "text/csv" });
	  
	  window.navigator.msSaveBlob(blob, savefileName);
	})
	.fail(function(data) {
		//alert("err");
	})
	
}

//************************
//*更新ボタンクリック
//************************
function UpdateDayCsv()
{
	
	//table要素に子供がいたら削除する
	$("#tbl").empty();
	
	var csvFile = CreateCsvFile();

	$.ajax({
			url: csvFile,
			type: 'GET',
			dataType: 'text',
			cache: false,
			async: false,
			timeout: 30000,
			beforeSend: function(xhr){
				xhr.overrideMimeType("text/html;charset=Shift_JIS");
		  },
			
	})
	.done(function(data) {
		ViewDayCsvDatav(data);
	})
	.fail(function(data) {
		//alert("err");
	})
}

//************************
//*CSV表示
//************************
function ViewDayCsvDatav(data)
{
	//CSV分割
	var csv = $.csv.toArrays(data);

	var num = 0;
  var target = '#tbl';
  var tbl;
  var td_str = "<td class = \"koumoku\">";
  
  //CSVを配列に格納
  var csv = $.csv.toArrays(data);

	//表のヘッダー作成
	switch (csvMode){
		case 0:
			tbl = '<tr>' + td_str + common.csvMode0.headder1 + '</td>' + td_str + common.csvMode0.headder2 + '</td>' + td_str + common.csvMode0.headder3 + '</td>' + td_str + common.csvMode0.headder4 + '</td></tr>';
	    	break;
		case 1:
			tbl = '<tr>' + td_str + common.csvMode1.headder1 + '</td>' + td_str + common.csvMode1.headder2 + '</td>' + td_str + common.csvMode1.headder3 + '</td>' + td_str + common.csvMode1.headder4 + '</td></tr>';
	    	break;
		case 2:
			tbl = '<tr>' + td_str + common.csvMode2.headder1 + '</td>' + td_str + common.csvMode2.headder2 + '</td>' + td_str + common.csvMode2.headder3 + '</td>' + td_str + common.csvMode2.headder4 + '</td></tr>';
	    	break;
		case 3:
			tbl = '<tr>' + td_str + common.csvMode3.headder1 + '</td>' + td_str + common.csvMode3.headder2 + '</td>' + td_str + common.csvMode3.headder3 + '</td>' + td_str + common.csvMode3.headder4 + '</td>' + td_str + common.csvMode3.headder5 + '</td>'+ td_str + common.csvMode3.headder6 + '</td></tr>';
	    	break;
		case 4:
	    	break;
		    	
	  default:
	    	console.log('csvModeがhtmlで設定されていない');
	}
	
		    	
  $(csv).each(function () 
  {
		//2行目まではヘッダーのため読み込まない
		if(num > 1)
		{
			if (this[0].length > 0) 
			{
				for(var i = 0; i < this.length; i++)
				{
					//データが無いまたはスペースしか入っていない場合はハイフンを入れる
					if(this[i] == "" || this[i] == " ")
					{
						this[i] = String.fromCharCode(0xFF0D);
					}
				}
											
				switch (csvMode){
					case 0:
					case 1:
					case 2:
						tbl += '<tr><td>' + this[0] + '</td>' + '<td>' + this[3] + '</td>' + '<td>' + this[1] + '</td>' + '<td>' + this[2] + '</td></tr>';
						break;
					
					case 3:
						tbl += '<tr><td>' + this[0] + '</td>' + '<td>' + this[1] + '</td>' + '<td>' + this[2] + '</td>' + '<td>' + this[5] + '</td>' + '<td>' + this[3] + '</td>' + '<td>' + this[4] + '</td></tr>';
						break;
						
					default:
    				console.log('csvModeがhtmlで設定されていない');
				}
/*
				for(var i =0; i< this.length; i++)
				{
					console.log(this[i]);
				}
*/
			}
		}
		num += 1;
  });
  
  $(target).append(tbl);

}


